#!/usr/bin/env node
"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var import_picocolors = __toESM(require("picocolors"));
var import_envinfo = __toESM(require("envinfo"));
var import_commander = require("commander");
var import_utils = require("@mango-scripts/utils");
var import_dev = __toESM(require("./scripts/dev"));
var import_build = __toESM(require("./scripts/build"));
var import_inspect = __toESM(require("./scripts/inspect"));
const packageJson = require("../../package.json");
const { engines, name, version } = packageJson;
(0, import_utils.checkNodeVersion)(engines.node, name);
(0, import_utils.checkUpdate)(packageJson);
console.log((0, import_utils.gs)("@mango-scripts/react-scripts"));
const program = new import_commander.Command();
program.version(`${name} ${version}`).usage("<command> [options]");
program.command("dev").description("\u542F\u52A8\u5F00\u53D1\u670D\u52A1\u5668").option(
  "-m --mode <mode>",
  "\u6307\u5B9A\u73AF\u5883\u6A21\u5F0F (\u9ED8\u8BA4\u503C\uFF1Adevelopment)",
  "development"
).allowUnknownOption().action((options) => {
  const { mode } = options;
  (0, import_dev.default)(mode);
});
program.command("build").description("\u6784\u5EFA\u6253\u5305\u5E94\u7528").option("-m --mode <mode>", "\u6307\u5B9A\u73AF\u5883\u6A21\u5F0F (\u9ED8\u8BA4\u503C\uFF1Aproduction)", "production").allowUnknownOption().action((options) => {
  const { mode } = options;
  (0, import_build.default)(mode);
});
program.command("inspect").description("\u6253\u5370 webpack \u914D\u7F6E").option("-m --mode <mode>", "\u6307\u5B9A\u73AF\u5883\u6A21\u5F0F (\u9ED8\u8BA4\u503C\uFF1Aproduction)", "production").allowUnknownOption().action((options) => {
  const { mode } = options;
  (0, import_inspect.default)(mode);
});
program.command("info").description("\u6253\u5370\u8FD0\u884C\u73AF\u5883\u53C2\u6570").action(() => {
  console.log(import_picocolors.default.bold("\nEnvironment Info:"));
  import_envinfo.default.run(
    {
      System: ["OS", "CPU", "Memory", "Shell"],
      Binaries: ["Node", "Yarn", "npm"],
      Browsers: ["Chrome", "Edge", "Firefox", "Safari"],
      npmPackages: "/**/{typescript,*react*}"
    },
    {
      showNotFound: true,
      duplicates: true,
      fullTree: true
    }
  ).then(console.log);
});
program.on("command:*", ([cmd]) => {
  program.outputHelp();
  console.log(import_picocolors.default.red(`Unknown command ${import_picocolors.default.yellow(cmd)}.`));
  console.log();
  process.exitCode = 1;
});
program.on("--help", () => {
  console.log();
  console.log(
    `  Run ${import_picocolors.default.cyan(
      `${name} <command> --help`
    )} for detailed usage of given command.`
  );
  console.log();
});
program.commands.forEach((c) => c.on("--help", () => console.log()));
program.parse(process.argv);
