"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var getEnv_exports = {};
__export(getEnv_exports, {
  applyEnv: () => applyEnv,
  getClientEnvironment: () => getClientEnvironment
});
module.exports = __toCommonJS(getEnv_exports);
var import_fs_extra = __toESM(require("fs-extra"));
var import_dotenv = __toESM(require("dotenv"));
var import_dotenv_expand = __toESM(require("dotenv-expand"));
var import_getPaths = require("./getPaths");
var import_getMode = require("./getMode");
const applyEnv = (mode, cliMode) => {
  const paths = (0, import_getPaths.getPaths)();
  Object.entries(import_getMode.cliEnv[cliMode]).forEach(([key, value]) => {
    process.env[key] = value;
  });
  const matchEnv = import_getMode.recommendProductionEnv[mode];
  matchEnv && Object.entries(matchEnv).forEach(([key, value]) => {
    process.env[key] = value;
  });
  const dotenvFiles = [
    `${paths.dotenv}`,
    `${paths.dotenv}.${cliMode}`,
    `${paths.dotenv}.${mode}`,
    `${paths.dotenv}.${mode}.local`
  ];
  dotenvFiles.forEach((dotenvFile) => {
    if (import_fs_extra.default.existsSync(dotenvFile)) {
      import_dotenv_expand.default.expand(import_dotenv.default.config({ path: dotenvFile, override: true }));
    }
  });
};
const getClientEnvironment = (publicUrl) => {
  const REACT_APP = /^REACT_APP_/i;
  const raw = Object.keys(process.env).filter((key) => REACT_APP.test(key)).reduce(
    (env, key) => {
      env[key] = process.env[key];
      return env;
    },
    {
      // Useful for resolving the correct path to static assets in `public`.
      // For example, <img src={process.env.PUBLIC_URL + '/img/logo.png'} />.
      // This should only be used as an escape hatch. Normally you would put
      // images into the `src` and `import` them in code to get their paths.
      PUBLIC_URL: publicUrl,
      // We support configuring the sockjs pathname during development.
      // These settings let a developer run multiple simultaneous projects.
      // They are used as the connection `hostname`, `pathname` and `port`
      // in webpackHotDevClient. They are used as the `sockHost`, `sockPath`
      // and `sockPort` options in webpack-dev-server.
      WDS_SOCKET_HOST: process.env.WDS_SOCKET_HOST,
      WDS_SOCKET_PATH: process.env.WDS_SOCKET_PATH,
      WDS_SOCKET_PORT: process.env.WDS_SOCKET_PORT
    }
  );
  const stringified = {
    "process.env": Object.keys(raw).reduce((env, key) => {
      env[key] = JSON.stringify(raw[key]);
      return env;
    }, {})
  };
  return { raw, stringified };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  applyEnv,
  getClientEnvironment
});
