"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var getHttpsConfig_exports = {};
__export(getHttpsConfig_exports, {
  getHttpsConfig: () => getHttpsConfig
});
module.exports = __toCommonJS(getHttpsConfig_exports);
var import_path = __toESM(require("path"));
var import_crypto = __toESM(require("crypto"));
var import_fs_extra = __toESM(require("fs-extra"));
var import_picocolors = __toESM(require("picocolors"));
var import_getPaths = require("./getPaths");
const validateKeyAndCerts = ({
  cert,
  key,
  crtFilePath,
  keyFilePath
}) => {
  let encrypted;
  try {
    encrypted = import_crypto.default.publicEncrypt(cert, Buffer.from("test"));
  } catch (err) {
    throw new Error(
      `The certificate "${import_picocolors.default.yellow(crtFilePath)}" is invalid.
${err.message}`
    );
  }
  try {
    import_crypto.default.privateDecrypt(key, encrypted);
  } catch (err) {
    throw new Error(
      `The certificate key "${import_picocolors.default.yellow(keyFilePath)}" is invalid.
${err.message}`
    );
  }
};
const readEnvFile = (file, type) => {
  if (!import_fs_extra.default.existsSync(file)) {
    throw new Error(
      `You specified ${import_picocolors.default.cyan(
        type
      )} in your env, but the file "${import_picocolors.default.yellow(file)}" can't be found.`
    );
  }
  return import_fs_extra.default.readFileSync(file);
};
const getHttpsConfig = () => {
  const paths = (0, import_getPaths.getPaths)();
  const { SSL_CRT_FILE_PATH, SSL_KEY_FILE_PATH, USE_HTTPS } = process.env;
  const useHttps = USE_HTTPS === "true";
  if (useHttps && SSL_CRT_FILE_PATH && SSL_KEY_FILE_PATH) {
    const crtFilePath = import_path.default.resolve(paths.appPath, SSL_CRT_FILE_PATH);
    const keyFilePath = import_path.default.resolve(paths.appPath, SSL_KEY_FILE_PATH);
    const config = {
      cert: readEnvFile(crtFilePath, "SSL_CRT_FILE_PATH"),
      key: readEnvFile(keyFilePath, "SSL_KEY_FILE_PATH")
    };
    validateKeyAndCerts({ ...config, crtFilePath, keyFilePath });
    return config;
  }
  return useHttps;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getHttpsConfig
});
