"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var getMinimizerConfig_exports = {};
__export(getMinimizerConfig_exports, {
  getCssMinimizer: () => getCssMinimizer,
  getJsMinimizer: () => getJsMinimizer
});
module.exports = __toCommonJS(getMinimizerConfig_exports);
var import_terser_webpack_plugin = __toESM(require("terser-webpack-plugin"));
var import_css_minimizer_webpack_plugin = __toESM(require("css-minimizer-webpack-plugin"));
var import_getUserConfig = require("./getUserConfig");
const getJsMinimizer = () => {
  const useProfile = process.env.USE_PROFILE === "true";
  const { minify, terserOptions } = (0, import_getUserConfig.getUserConfig)(
    "optimization.minimizer.jsMinimizer"
  );
  switch (minify) {
    case "uglifyJsMinify":
      return new import_terser_webpack_plugin.default({
        minify: import_terser_webpack_plugin.default.uglifyJsMinify,
        terserOptions
      });
    case "esbuildMinify":
      return new import_terser_webpack_plugin.default({
        minify: import_terser_webpack_plugin.default.esbuildMinify,
        terserOptions
      });
    case "swcMinify":
      return new import_terser_webpack_plugin.default({
        minify: import_terser_webpack_plugin.default.swcMinify,
        terserOptions
      });
    default:
      return new import_terser_webpack_plugin.default({
        minify: import_terser_webpack_plugin.default.terserMinify,
        terserOptions: (0, import_getUserConfig.deepMergeWithArray)(terserOptions, {
          parse: {
            // We want terser to parse ecma 8 code. However, we don't want it
            // to apply any minification steps that turns valid ecma 5 code
            // into invalid ecma 5 code. This is why the 'compress' and 'output'
            // sections only apply transformations that are ecma 5 safe
            // https://github.com/facebook/create-react-app/pull/4234
            ecma: 2020
          },
          compress: {
            ecma: 5,
            // Disabled because of an issue with Uglify breaking seemingly valid code:
            // https://github.com/facebook/create-react-app/issues/2376
            // Pending further investigation:
            // https://github.com/mishoo/UglifyJS2/issues/2011
            comparisons: false,
            // Disabled because of an issue with Terser breaking valid code:
            // https://github.com/facebook/create-react-app/issues/5250
            // Pending further investigation:
            // https://github.com/terser-js/terser/issues/120
            inline: 2
          },
          mangle: {
            safari10: true
          },
          // Added for profiling in devtools
          keep_classnames: useProfile,
          keep_fnames: useProfile,
          output: {
            ecma: 5,
            comments: false,
            // Turned on because emoji and regex is not minified properly using default
            // https://github.com/facebook/create-react-app/issues/2488
            ascii_only: true
          }
        })
      });
  }
};
const getCssMinimizer = () => {
  const { minify, minimizerOptions } = (0, import_getUserConfig.getUserConfig)(
    "optimization.minimizer.cssMinimizer"
  );
  switch (minify) {
    case "cssoMinify":
      return new import_css_minimizer_webpack_plugin.default({
        minify: import_css_minimizer_webpack_plugin.default.cssoMinify,
        minimizerOptions
      });
    case "cleanCssMinify":
      return new import_css_minimizer_webpack_plugin.default({
        minify: import_css_minimizer_webpack_plugin.default.cleanCssMinify,
        minimizerOptions
      });
    case "esbuildMinify":
      return new import_css_minimizer_webpack_plugin.default({
        minify: import_css_minimizer_webpack_plugin.default.esbuildMinify,
        minimizerOptions
      });
    case "lightningCssMinify":
      return new import_css_minimizer_webpack_plugin.default({
        minify: import_css_minimizer_webpack_plugin.default.lightningCssMinify,
        minimizerOptions
      });
    case "swcMinify":
      return new import_css_minimizer_webpack_plugin.default({
        minify: import_css_minimizer_webpack_plugin.default.swcMinify,
        minimizerOptions
      });
    default:
      return new import_css_minimizer_webpack_plugin.default({
        minify: import_css_minimizer_webpack_plugin.default.cssnanoMinify,
        minimizerOptions: (0, import_getUserConfig.deepMergeWithArray)(minimizerOptions, {
          preset: "default"
        })
      });
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getCssMinimizer,
  getJsMinimizer
});
