"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var getModules_exports = {};
__export(getModules_exports, {
  getModules: () => getModules
});
module.exports = __toCommonJS(getModules_exports);
var import_path = __toESM(require("path"));
var import_fs_extra = __toESM(require("fs-extra"));
var import_picocolors = __toESM(require("picocolors"));
var import_resolve = __toESM(require("resolve"));
var import_getPaths = require("./getPaths");
const getAdditionalModulePaths = (options = {}) => {
  const paths = (0, import_getPaths.getPaths)();
  const baseUrl = options.baseUrl;
  if (!baseUrl) {
    return "";
  }
  const baseUrlResolved = import_path.default.resolve(paths.appPath, baseUrl);
  if (import_path.default.relative(paths.appNodeModules, baseUrlResolved) === "") {
    return null;
  }
  if (import_path.default.relative(paths.appSrc, baseUrlResolved) === "") {
    return [paths.appSrc];
  }
  if (import_path.default.relative(paths.appPath, baseUrlResolved) === "") {
    return null;
  }
  throw new Error(
    import_picocolors.default.red(
      import_picocolors.default.bold(
        "Your project's `baseUrl` can only be set to `src` or `node_modules`. Create React App does not support other values at this time."
      )
    )
  );
};
const getWebpackAliases = (options = {}) => {
  const paths = (0, import_getPaths.getPaths)();
  const baseUrl = options.baseUrl;
  if (!baseUrl) {
    return {};
  }
  const baseUrlResolved = import_path.default.resolve(paths.appPath, baseUrl);
  if (import_path.default.relative(paths.appPath, baseUrlResolved) === "") {
    return {
      src: paths.appSrc
    };
  } else {
    return {};
  }
};
const getModules = () => {
  const paths = (0, import_getPaths.getPaths)();
  const hasTsConfig = import_fs_extra.default.existsSync(paths.appTsConfig);
  const hasJsConfig = import_fs_extra.default.existsSync(paths.appJsConfig);
  if (hasTsConfig && hasJsConfig) {
    throw new Error(
      "You have both a tsconfig.json and a jsconfig.json. If you are using TypeScript please remove your jsconfig.json file."
    );
  }
  let config;
  if (hasTsConfig) {
    const ts = require(import_resolve.default.sync("typescript", {
      basedir: paths.appNodeModules
    }));
    config = ts.readConfigFile(paths.appTsConfig, ts.sys.readFile).config;
  } else if (hasJsConfig) {
    config = require(paths.appJsConfig);
  }
  config = config || {};
  const options = config.compilerOptions || {};
  const additionalModulePaths = getAdditionalModulePaths(options);
  return {
    additionalModulePaths,
    webpackAliases: getWebpackAliases(options),
    hasTsConfig
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getModules
});
