"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var getPaths_exports = {};
__export(getPaths_exports, {
  getPaths: () => getPaths
});
module.exports = __toCommonJS(getPaths_exports);
var import_path = __toESM(require("path"));
var import_fs_extra = __toESM(require("fs-extra"));
var import_getPublicUrlOrPath = __toESM(require("react-dev-utils/getPublicUrlOrPath"));
var import_getUserConfig = require("./getUserConfig");
const getPaths = () => {
  const appDirectory = import_fs_extra.default.realpathSync(process.cwd());
  const resolveApp = (relativePath) => import_path.default.resolve(appDirectory, relativePath);
  const publicUrlOrPath = (0, import_getPublicUrlOrPath.default)(
    process.env.NODE_ENV === "development",
    require(resolveApp("package.json")).homepage,
    process.env.PUBLIC_URL
  );
  const distDir = (0, import_getUserConfig.getUserConfig)("distDir");
  const moduleFileExtensions = [
    "web.mjs",
    "mjs",
    "web.js",
    "js",
    "web.ts",
    "ts",
    "web.tsx",
    "tsx",
    "json",
    "web.jsx",
    "jsx"
  ];
  const resolveModule = (resolveFn, filePath) => {
    const extension = moduleFileExtensions.find(
      (extension2) => import_fs_extra.default.existsSync(resolveFn(`${filePath}.${extension2}`))
    );
    if (extension) {
      return resolveFn(`${filePath}.${extension}`);
    }
    return resolveFn(`${filePath}.js`);
  };
  const paths = {
    dotenv: resolveApp(".env"),
    appPath: resolveApp("."),
    appDist: resolveApp(distDir),
    appPublic: resolveApp("public"),
    appHtml: resolveApp("public/index.html"),
    appIndexJs: resolveModule(resolveApp, "src/index"),
    appPackageJson: resolveApp("package.json"),
    appSrc: resolveApp("src"),
    appTsConfig: resolveApp("tsconfig.json"),
    appJsConfig: resolveApp("jsconfig.json"),
    proxySetup: resolveApp("src/setupProxy.js"),
    appNodeModules: resolveApp("node_modules"),
    appWebpackCache: resolveApp("node_modules/.cache"),
    appTsBuildInfoFile: resolveApp("node_modules/.cache/tsconfig.tsbuildinfo"),
    swSrc: resolveModule(resolveApp, "src/service-worker"),
    publicUrlOrPath,
    svgSpritePath: resolveApp("src/icons/svg"),
    moduleFileExtensions
  };
  return paths;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getPaths
});
