"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var getUserConfig_exports = {};
__export(getUserConfig_exports, {
  deepMergeWithArray: () => deepMergeWithArray,
  getUserConfig: () => getUserConfig
});
module.exports = __toCommonJS(getUserConfig_exports);
var import_fs_extra = __toESM(require("fs-extra"));
var import_lodash = require("lodash");
var import_cosmiconfig = require("cosmiconfig");
const defaultUserConfig = {
  distDir: "dist",
  loader: {
    babel: {
      options: {}
    },
    less: {
      options: {}
    },
    sass: {
      options: {}
    },
    stylus: {
      options: {}
    },
    postcss: {
      options: {}
    }
  },
  plugin: {
    eslint: {
      enable: true,
      options: {}
    },
    stylelint: {
      enable: true,
      options: {}
    },
    typescript: {
      enable: true,
      options: {}
    }
  },
  optimization: {
    splitChunks: {},
    minimizer: {
      jsMinimizer: {
        minify: "terserMinify",
        // terserMinify | uglifyJsMinify | esbuildMinify | swcMinify
        terserOptions: {}
      },
      cssMinimizer: {
        minify: "cssnanoMinify",
        // cssnanoMinify | cssoMinify | cleanCssMinify | esbuildMinify  | lightningCssMinify | swcMinify
        minimizerOptions: {}
      }
    }
  }
};
const deepMergeWithArray = (object, sources) => {
  return (0, import_lodash.mergeWith)(object, sources, (objValue, srcValue) => {
    if ((0, import_lodash.isArray)(objValue)) {
      return objValue.concat(srcValue);
    }
  });
};
const getUserConfig = (targetConfigObjPath) => {
  const projectRoot = import_fs_extra.default.realpathSync(process.cwd());
  const userConfigExplorer = (0, import_cosmiconfig.cosmiconfigSync)("mango");
  const userConfigFilePath = userConfigExplorer.search(projectRoot);
  if (userConfigFilePath !== null) {
    const userConfig = userConfigExplorer.load(userConfigFilePath.filepath);
    if (!userConfig?.config) {
      throw new Error("mango: Config function didn't return a config object.");
    }
    return (0, import_lodash.get)(
      deepMergeWithArray(defaultUserConfig, userConfig?.config),
      targetConfigObjPath
    );
  }
  return (0, import_lodash.get)(defaultUserConfig, targetConfigObjPath);
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  deepMergeWithArray,
  getUserConfig
});
