"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var webpack_config_exports = {};
__export(webpack_config_exports, {
  getWebpackConfig: () => getWebpackConfig
});
module.exports = __toCommonJS(webpack_config_exports);
var import_path = __toESM(require("path"));
var import_fs_extra = __toESM(require("fs-extra"));
var import_webpack = __toESM(require("webpack"));
var import_resolve = __toESM(require("resolve"));
var import_html_webpack_plugin = __toESM(require("html-webpack-plugin"));
var import_mini_css_extract_plugin = __toESM(require("mini-css-extract-plugin"));
var import_webpack_manifest_plugin = require("webpack-manifest-plugin");
var import_webpack_bundle_analyzer = require("webpack-bundle-analyzer");
var import_workbox_webpack_plugin = __toESM(require("workbox-webpack-plugin"));
var import_eslint_webpack_plugin = __toESM(require("eslint-webpack-plugin"));
var import_stylelint_webpack_plugin = __toESM(require("stylelint-webpack-plugin"));
var import_case_sensitive_paths_webpack_plugin = __toESM(require("case-sensitive-paths-webpack-plugin"));
var import_react_refresh_webpack_plugin = __toESM(require("@pmmmwh/react-refresh-webpack-plugin"));
var import_webpackbar = __toESM(require("webpackbar"));
var import_InterpolateHtmlPlugin = __toESM(require("react-dev-utils/InterpolateHtmlPlugin"));
var import_InlineChunkHtmlPlugin = __toESM(require("react-dev-utils/InlineChunkHtmlPlugin"));
var import_ForkTsCheckerWebpackPlugin = __toESM(require("react-dev-utils/ForkTsCheckerWebpackPlugin"));
var import_ModuleNotFoundPlugin = __toESM(require("react-dev-utils/ModuleNotFoundPlugin"));
var import_ModuleScopePlugin = __toESM(require("react-dev-utils/ModuleScopePlugin"));
var import_getPaths = require("./getPaths");
var import_getModules = require("./getModules");
var import_getEnv = require("./getEnv");
var import_getMinimizerConfig = require("./getMinimizerConfig");
var import_getModuleRules = require("./getModuleRules");
var import_getUserConfig = require("./getUserConfig");
var import_utils = require("../utils");
const getWebpackConfig = () => {
  const isEnvDevelopment = process.env.NODE_ENV === "development";
  const isEnvProduction = process.env.NODE_ENV === "production";
  const useSourceMap = process.env.USE_SOURCEMAP === "true";
  const useBundleAnalyzerPlugin = process.env.USE_ANALYZE === "true";
  const useProfile = process.env.USE_PROFILE === "true";
  const paths = (0, import_getPaths.getPaths)();
  const modules = (0, import_getModules.getModules)();
  const splitChunks = (0, import_getUserConfig.getUserConfig)("optimization.splitChunks");
  const { eslint, stylelint, typescript } = (0, import_getUserConfig.getUserConfig)("plugin");
  const env = (0, import_getEnv.getClientEnvironment)(paths.publicUrlOrPath.slice(0, -1));
  const reactRefreshRuntimeEntry = require.resolve("react-refresh/runtime");
  const reactRefreshWebpackPluginRuntimeEntry = require.resolve("@pmmmwh/react-refresh-webpack-plugin");
  const babelRuntimeEntry = require.resolve("babel-preset-react-app");
  const babelRuntimeEntryHelpers = require.resolve(
    "@babel/runtime/helpers/esm/assertThisInitialized",
    { paths: [babelRuntimeEntry] }
  );
  const babelRuntimeRegenerator = require.resolve(
    "@babel/runtime/regenerator",
    {
      paths: [babelRuntimeEntry]
    }
  );
  return {
    target: ["browserslist"],
    // Webpack noise constrained to errors and warnings
    stats: "errors-warnings",
    mode: isEnvProduction ? "production" : isEnvDevelopment ? "development" : void 0,
    // Stop compilation early in production
    bail: isEnvProduction,
    devtool: isEnvProduction ? useSourceMap ? "source-map" : false : isEnvDevelopment && "cheap-module-source-map",
    // These are the "entry points" to our application.
    // This means they will be the "root" imports that are included in JS bundle.
    entry: paths.appIndexJs,
    output: {
      // The dist folder.
      path: paths.appDist,
      // Add /* filename */ comments to generated require()s in the output.
      pathinfo: isEnvDevelopment,
      // There will be one main bundle, and one file per asynchronous chunk.
      // In development, it does not produce real files.
      filename: isEnvProduction ? "static/js/[name].[contenthash:16].js" : isEnvDevelopment ? "static/js/bundle.js" : void 0,
      // There are also additional JS chunk files if you use code splitting.
      chunkFilename: isEnvProduction ? "static/js/[name].[contenthash:16].chunk.js" : isEnvDevelopment ? "static/js/[name].chunk.js" : void 0,
      assetModuleFilename: "static/media/[name].[hash][ext]",
      // webpack uses `publicPath` to determine where the app is being served from.
      // It requires a trailing slash, or the file assets will get an incorrect path.
      // We inferred the "public path" (such as / or /my-project) from homepage.
      publicPath: paths.publicUrlOrPath,
      // Point sourcemap entries to original disk location (format as URL on Windows)
      devtoolModuleFilenameTemplate: isEnvProduction ? (info) => import_path.default.relative(paths.appSrc, info.absoluteResourcePath).replace(/\\/g, "/") : isEnvDevelopment ? (info) => import_path.default.resolve(info.absoluteResourcePath).replace(/\\/g, "/") : void 0
    },
    cache: {
      type: "filesystem",
      version: (0, import_utils.getHash)(env.raw),
      cacheDirectory: paths.appWebpackCache,
      store: "pack",
      buildDependencies: {
        defaultWebpack: ["webpack/lib/"],
        config: [__filename],
        tsconfig: [paths.appTsConfig, paths.appJsConfig].filter(
          (f) => import_fs_extra.default.existsSync(f)
        )
      }
    },
    infrastructureLogging: {
      level: "none"
    },
    optimization: {
      minimize: isEnvProduction,
      splitChunks: isEnvProduction && (0, import_getUserConfig.deepMergeWithArray)(splitChunks, {
        chunks: "all",
        cacheGroups: {
          libs: {
            name: "chunk-libs",
            test: /[\\/]node_modules[\\/]/,
            priority: 10,
            chunks: "initial"
            // only package third parties that are initially dependent
          },
          antd: {
            name: "chunk-antd",
            // split elementUI into a single package
            priority: 12,
            // the weight needs to be larger than libs and app or it will be packaged into libs or app
            test: /[\\/]node_modules[\\/]_?antd(.*)/
            // in order to adapt to cnpm
          },
          elementUI: {
            name: "chunk-elementUI",
            // split elementUI into a single package
            priority: 22,
            // the weight needs to be larger than libs and app or it will be packaged into libs or app
            test: /[\\/]node_modules[\\/]_?element-ui(.*)/
            // in order to adapt to cnpm
          },
          d3: {
            name: "chunk-d3",
            // split d3 into a single package
            priority: 22,
            // the weight needs to be larger than libs and app or it will be packaged into libs or app
            test: /[\\/]node_modules[\\/]d3/
            // in order to adapt to cnpm
          },
          echarts: {
            name: "chunk-echarts",
            // split echarts into a single package
            priority: 22,
            // the weight needs to be larger than libs and app or it will be packaged into libs or app
            test: /[\\/]node_modules[\\/]echarts/
            // in order to adapt to cnpm
          },
          exceljs: {
            name: "chunk-exceljs",
            // split exceljs into a single package
            priority: 22,
            // the weight needs to be larger than libs and app or it will be packaged into libs or app
            test: /[\\/]node_modules[\\/]exceljs/
            // in order to adapt to cnpm
          },
          xlsx: {
            name: "chunk-xlsx",
            // split xlsx into a single package
            priority: 22,
            // the weight needs to be larger than libs and app or it will be packaged into libs or app
            test: /[\\/]node_modules[\\/]xlsx/
            // in order to adapt to cnpm
          }
        }
      }),
      minimizer: [
        // This is only used in production mode
        (0, import_getMinimizerConfig.getJsMinimizer)(),
        (0, import_getMinimizerConfig.getCssMinimizer)()
      ]
    },
    resolve: {
      // This allows you to set a fallback for where webpack should look for modules.
      // We placed these paths second because we want `node_modules` to "win"
      // if there are any conflicts. This matches Node resolution mechanism.
      // https://github.com/facebook/create-react-app/issues/253
      modules: ["node_modules", paths.appNodeModules].concat(
        modules.additionalModulePaths || []
      ),
      // These are the reasonable defaults supported by the Node ecosystem.
      // We also include JSX as a common component filename extension to support
      // some tools, although we do not recommend using it, see:
      // https://github.com/facebook/create-react-app/issues/290
      // `web` extension prefixes have been added for better support
      // for React Native Web.
      extensions: paths.moduleFileExtensions.map((ext) => `.${ext}`),
      alias: {
        "@": paths.appSrc,
        // Allows for better profiling with ReactDevTools
        ...isEnvProduction && useProfile ? {
          "react-dom$": "react-dom/profiling",
          "scheduler/tracing": "scheduler/tracing-profiling"
        } : {},
        ...modules.webpackAliases
      },
      plugins: [
        // Prevents users from importing files from outside of src/ (or node_modules/).
        // This often causes confusion because we only process files within src/ with babel.
        // To fix this, we prevent you from importing files out of src/ -- if you'd like to,
        // please link the files into your node_modules/ and let module-resolution kick in.
        // Make sure your source files are compiled, as they will not be processed in any way.
        new import_ModuleScopePlugin.default(paths.appSrc, [
          paths.appPackageJson,
          reactRefreshRuntimeEntry,
          reactRefreshWebpackPluginRuntimeEntry,
          babelRuntimeEntry,
          babelRuntimeEntryHelpers,
          babelRuntimeRegenerator
        ])
      ]
    },
    module: {
      parser: { javascript: { strictExportPresence: true } },
      rules: (0, import_getModuleRules.getModuleRules)()
    },
    plugins: [
      // Generates an `index.html` file with the <script> injected.
      new import_html_webpack_plugin.default(
        Object.assign(
          {},
          {
            inject: true,
            template: paths.appHtml
          },
          isEnvProduction ? {
            minify: {
              removeComments: true,
              collapseWhitespace: true,
              removeRedundantAttributes: true,
              useShortDoctype: true,
              removeEmptyAttributes: true,
              removeStyleLinkTypeAttributes: true,
              keepClosingSlash: true,
              minifyJS: true,
              minifyCSS: true,
              minifyURLs: true
            }
          } : void 0
        )
      ),
      // Inlines the webpack runtime script. This script is too small to warrant
      // a network request.
      // https://github.com/facebook/create-react-app/issues/5358
      isEnvProduction && new import_InlineChunkHtmlPlugin.default(import_html_webpack_plugin.default, [
        /runtime-.+[.]js/
      ]),
      // Makes some environment variables available in index.html.
      // The public URL is available as %PUBLIC_URL% in index.html, e.g.:
      // <link rel="icon" href="%PUBLIC_URL%/favicon.ico">
      // It will be an empty string unless you specify "homepage"
      // in `package.json`, in which case it will be the pathname of that URL.
      new import_InterpolateHtmlPlugin.default(import_html_webpack_plugin.default, env.raw),
      // This gives some necessary context to module not found errors, such as
      // the requesting resource.
      new import_ModuleNotFoundPlugin.default(paths.appPath),
      // Makes some environment variables available to the JS code, for example:
      // if (process.env.NODE_ENV === 'production') { ... }. See `./env.js`.
      // It is absolutely essential that NODE_ENV is set to production
      // during a production build.
      // Otherwise React will be compiled in the very slow development mode.
      new import_webpack.default.DefinePlugin(env.stringified),
      // Experimental hot reloading for React .
      // https://github.com/facebook/react/tree/main/packages/react-refresh
      isEnvDevelopment && new import_react_refresh_webpack_plugin.default({
        overlay: false
      }),
      // Watcher doesn't work well if you mistype casing in a path so we use
      // a plugin that prints an error when you attempt to do this.
      // See https://github.com/facebook/create-react-app/issues/240
      isEnvDevelopment && new import_case_sensitive_paths_webpack_plugin.default(),
      isEnvProduction && new import_mini_css_extract_plugin.default({
        // Options similar to the same options in webpackOptions.output
        // both options are optional
        filename: "static/css/[name].[contenthash:16].css",
        chunkFilename: "static/css/[name].[contenthash:16].chunk.css"
      }),
      // Generate an asset manifest file with the following content:
      // - "files" key: Mapping of all asset filenames to their corresponding
      //   output file so that tools can pick it up without having to parse
      //   `index.html`
      // - "entrypoints" key: Array of files which are included in `index.html`,
      //   can be used to reconstruct the HTML if necessary
      isEnvProduction && new import_webpack_manifest_plugin.WebpackManifestPlugin({
        fileName: "asset-manifest.json",
        publicPath: paths.publicUrlOrPath,
        generate: (seed, files, entrypoints) => {
          const manifestFiles = files.reduce((manifest, file) => {
            manifest[file.name] = file.path;
            return manifest;
          }, seed);
          const entrypointFiles = entrypoints.main.filter(
            (fileName) => !fileName.endsWith(".map")
          );
          return {
            files: manifestFiles,
            entrypoints: entrypointFiles
          };
        }
      }),
      // Generate a service worker script that will precache, and keep up to date,
      // the HTML & assets that are part of the webpack build.
      isEnvProduction && import_fs_extra.default.existsSync(paths.swSrc) && new import_workbox_webpack_plugin.default.InjectManifest({
        swSrc: paths.swSrc,
        dontCacheBustURLsMatching: /\.[0-9a-f]{8}\./,
        exclude: [/\.map$/, /asset-manifest\.json$/, /LICENSE/],
        // Bump up the default maximum size (2mb) that's precached,
        // to make lazy-loading failure scenarios less likely.
        // See https://github.com/cra-template/pwa/issues/13#issuecomment-722667270
        maximumFileSizeToCacheInBytes: 5 * 1024 * 1024
      }),
      // TypeScript type checking
      typescript?.enable && new import_ForkTsCheckerWebpackPlugin.default(
        (0, import_getUserConfig.deepMergeWithArray)(typescript?.options, {
          async: isEnvDevelopment,
          typescript: {
            typescriptPath: import_resolve.default.sync("typescript", {
              basedir: paths.appNodeModules
            }),
            configOverwrite: {
              compilerOptions: {
                sourceMap: isEnvProduction ? useSourceMap : isEnvDevelopment,
                skipLibCheck: true,
                inlineSourceMap: false,
                declarationMap: false,
                noEmit: true,
                incremental: true,
                tsBuildInfoFile: paths.appTsBuildInfoFile
              }
            },
            context: paths.appPath,
            diagnosticOptions: {
              syntactic: true
            },
            mode: "write-references"
            // profile: true,
          },
          issue: {
            // This one is specifically to match during CI tests,
            // as micromatch doesn't match
            // '../cra-template-typescript/template/src/App.tsx'
            // otherwise.
            include: [
              { file: "../**/src/**/*.{ts,tsx}" },
              { file: "**/src/**/*.{ts,tsx}" }
            ],
            exclude: [
              { file: "**/src/**/__tests__/**" },
              { file: "**/src/**/?(*.){spec|test}.*" },
              { file: "**/src/setupProxy.*" },
              { file: "**/src/setupTests.*" }
            ]
          },
          logger: {
            infrastructure: "silent"
          }
        })
      ),
      eslint?.enable && new import_eslint_webpack_plugin.default(
        (0, import_getUserConfig.deepMergeWithArray)(eslint?.options, {
          extensions: ["js", "mjs", "jsx", "ts", "tsx"],
          formatter: require.resolve("react-dev-utils/eslintFormatter"),
          eslintPath: require.resolve("eslint"),
          failOnError: true,
          context: paths.appSrc,
          cache: true,
          cacheLocation: import_path.default.resolve(
            paths.appNodeModules,
            ".cache/.eslintcache"
          ),
          cwd: paths.appPath
        })
      ),
      stylelint?.enable && new import_stylelint_webpack_plugin.default(
        (0, import_getUserConfig.deepMergeWithArray)(stylelint?.options, {
          extensions: ["less", "scss", "sass", "stylus", "styl", "css"],
          stylelintPath: require.resolve("stylelint"),
          failOnError: isEnvProduction,
          context: paths.appSrc,
          cache: true,
          cacheLocation: import_path.default.resolve(
            paths.appNodeModules,
            ".cache/.stylelintcache"
          ),
          cwd: paths.appPath
        })
      ),
      useBundleAnalyzerPlugin && new import_webpack_bundle_analyzer.BundleAnalyzerPlugin(),
      new import_webpackbar.default()
    ].filter(Boolean),
    // Turn off performance processing because we utilize
    // our own hints via the FileSizeReporter
    performance: false
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getWebpackConfig
});
