"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var dev_exports = {};
__export(dev_exports, {
  default: () => dev_default
});
module.exports = __toCommonJS(dev_exports);
var import_fs_extra = __toESM(require("fs-extra"));
var import_picocolors = __toESM(require("picocolors"));
var import_webpack = __toESM(require("webpack"));
var import_webpack_dev_server = __toESM(require("webpack-dev-server"));
var import_clearConsole = __toESM(require("react-dev-utils/clearConsole"));
var import_checkRequiredFiles = __toESM(require("react-dev-utils/checkRequiredFiles"));
var import_WebpackDevServerUtils = require("react-dev-utils/WebpackDevServerUtils");
var import_openBrowser = __toESM(require("react-dev-utils/openBrowser"));
var import_browsersHelper = require("react-dev-utils/browsersHelper");
var import_evalSourceMapMiddleware = __toESM(require("react-dev-utils/evalSourceMapMiddleware"));
var import_noopServiceWorkerMiddleware = __toESM(require("react-dev-utils/noopServiceWorkerMiddleware"));
var import_ignoredFiles = __toESM(require("react-dev-utils/ignoredFiles"));
var import_redirectServedPathMiddleware = __toESM(require("react-dev-utils/redirectServedPathMiddleware"));
var import_getPaths = require("../config/getPaths");
var import_webpack2 = require("../config/webpack.config");
var import_getEnv = require("../config/getEnv");
var import_utils = require("../utils");
var import_getHttpsConfig = require("../config/getHttpsConfig");
process.on("unhandledRejection", (err) => {
  throw err;
});
const dev = async (mode) => {
  try {
    (0, import_getEnv.applyEnv)(mode, "development");
    const paths = (0, import_getPaths.getPaths)();
    const isInteractive = process.stdout.isTTY;
    if (!(0, import_checkRequiredFiles.default)([paths.appHtml, paths.appIndexJs])) {
      process.exit(1);
    }
    const useLocalHost = process.env.USE_LOCAL_HOST === "true";
    const useHttps = process.env.USE_HTTPS === "true";
    const defaultPort = Number(process.env.PORT || "3000");
    const host = useLocalHost && (0, import_utils.getLocalHost)() || "0.0.0.0";
    const sockHost = process.env.WDS_SOCKET_HOST || void 0;
    const sockPath = process.env.WDS_SOCKET_PATH || void 0;
    const sockPort = process.env.WDS_SOCKET_PORT || void 0;
    await (0, import_browsersHelper.checkBrowsers)(paths.appPath, isInteractive);
    const port = await (0, import_WebpackDevServerUtils.choosePort)(host, defaultPort);
    if (port == null) {
      console.log(import_picocolors.default.red("No port found, please check your environment"));
      return;
    }
    const config = await (0, import_webpack2.getWebpackConfig)();
    const protocol = useHttps ? "https" : "http";
    const appName = require(paths.appPackageJson).name;
    const urls = (0, import_WebpackDevServerUtils.prepareUrls)(
      protocol,
      host,
      port,
      paths.publicUrlOrPath.slice(0, -1)
    );
    const compiler = (0, import_WebpackDevServerUtils.createCompiler)({
      appName,
      config,
      urls,
      useYarn: false,
      useTypeScript: true,
      webpack: import_webpack.default
    });
    const proxySetting = require(paths.appPackageJson).proxy;
    const proxyConfig = (0, import_WebpackDevServerUtils.prepareProxy)(
      proxySetting,
      paths.appPublic,
      paths.publicUrlOrPath
    );
    const disableFirewall = !proxyConfig || process.env.DANGEROUSLY_DISABLE_HOST_CHECK === "true";
    const serverConfig = {
      // WebpackDevServer 2.4.3 introduced a security fix that prevents remote
      // websites from potentially accessing local content through DNS rebinding:
      // https://github.com/webpack/webpack-dev-server/issues/887
      // https://medium.com/webpack/webpack-dev-server-middleware-security-issues-1489d950874a
      // However, it made several existing use cases such as development in cloud
      // environment or subdomains in development significantly more complicated:
      // https://github.com/facebook/create-react-app/issues/2271
      // https://github.com/facebook/create-react-app/issues/2233
      // While we're investigating better solutions, for now we will take a
      // compromise. Since our WDS configuration only serves files in the `public`
      // folder we won't consider accessing them a vulnerability. However, if you
      // use the `proxy` feature, it gets more dangerous because it can expose
      // remote code execution vulnerabilities in backends like Django and Rails.
      // So we will disable the host check normally, but enable it if you have
      // specified the `proxy` setting. Finally, we let you override it if you
      // really know what you're doing with a special environment variable.
      // Note: ["localhost", ".localhost"] will support subdomains - but we might
      // want to allow setting the allowedHosts manually for more complex setups
      allowedHosts: disableFirewall ? "all" : [urls.lanUrlForConfig],
      headers: {
        "Access-Control-Allow-Origin": "*",
        "Access-Control-Allow-Methods": "*",
        "Access-Control-Allow-Headers": "*"
      },
      // Enable gzip compression of generated files.
      compress: true,
      static: {
        // By default WebpackDevServer serves physical files from current directory
        // in addition to all the virtual build products that it serves from memory.
        // This is confusing because those files won’t automatically be available in
        // production build folder unless we copy them. However, copying the whole
        // project directory is dangerous because we may expose sensitive files.
        // Instead, we establish a convention that only files in `public` directory
        // get served. Our build script will copy `public` into the `build` folder.
        // In `index.html`, you can get URL of `public` folder with %PUBLIC_URL%:
        // <link rel="icon" href="%PUBLIC_URL%/favicon.ico">
        // In JavaScript code, you can access it with `process.env.PUBLIC_URL`.
        // Note that we only recommend to use `public` folder as an escape hatch
        // for files like `favicon.ico`, `manifest.json`, and libraries that are
        // for some reason broken when imported through webpack. If you just want to
        // use an image, put it in `src` and `import` it from JavaScript instead.
        directory: paths.appPublic,
        publicPath: [paths.publicUrlOrPath],
        // By default files from `contentBase` will not trigger a page reload.
        watch: {
          // Reportedly, this avoids CPU overload on some systems.
          // https://github.com/facebook/create-react-app/issues/293
          // src/node_modules is not ignored to support absolute imports
          // https://github.com/facebook/create-react-app/issues/1065
          ignored: (0, import_ignoredFiles.default)(paths.appSrc)
        }
      },
      client: {
        webSocketURL: {
          // Enable custom sockjs pathname for websocket connection to hot reloading server.
          // Enable custom sockjs hostname, pathname and port for websocket connection
          // to hot reloading server.
          hostname: sockHost,
          pathname: sockPath,
          port: sockPort
        },
        overlay: {
          errors: true,
          warnings: false
        }
      },
      devMiddleware: {
        // It is important to tell WebpackDevServer to use the same "publicPath" path as
        // we specified in the webpack config. When homepage is '.', default to serving
        // from the root.
        // remove last slash so user can land on `/test` instead of `/test/`
        publicPath: paths.publicUrlOrPath.slice(0, -1)
      },
      https: (0, import_getHttpsConfig.getHttpsConfig)(),
      host,
      port,
      historyApiFallback: {
        // Paths with dots should still use the history fallback.
        // See https://github.com/facebook/create-react-app/issues/387.
        disableDotRule: true,
        index: paths.publicUrlOrPath
      },
      // `proxy` is run between `before` and `after` `webpack-dev-server` hooks
      proxy: proxyConfig,
      setupMiddlewares: (middlewares, devServer2) => {
        if (!devServer2) {
          throw new Error("webpack-dev-server is not defined");
        }
        devServer2.app.use((0, import_evalSourceMapMiddleware.default)(devServer2));
        if (import_fs_extra.default.existsSync(paths.proxySetup)) {
          require(paths.proxySetup)(devServer2.app);
        }
        devServer2.app.use((0, import_redirectServedPathMiddleware.default)(paths.publicUrlOrPath));
        devServer2.app.use((0, import_noopServiceWorkerMiddleware.default)(paths.publicUrlOrPath));
        return middlewares;
      }
    };
    const devServer = new import_webpack_dev_server.default(serverConfig, compiler);
    devServer.startCallback(() => {
      if (isInteractive) {
        (0, import_clearConsole.default)();
      }
      console.log(import_picocolors.default.cyan("Starting the development server...\n"));
      (0, import_openBrowser.default)(urls.localUrlForBrowser);
    });
    ["SIGINT", "SIGTERM"].forEach(function(sig) {
      process.on(sig, function() {
        devServer.close();
        process.exit();
      });
    });
    if (process.env.CI !== "true") {
      process.stdin.on("end", function() {
        devServer.close();
        process.exit();
      });
    }
  } catch (err) {
    if (err && err.message) {
      console.log(err.message);
    }
    process.exit(1);
  }
};
var dev_default = dev;
