"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var utils_exports = {};
__export(utils_exports, {
  getHash: () => getHash,
  getLocalHost: () => getLocalHost
});
module.exports = __toCommonJS(utils_exports);
var import_os = __toESM(require("os"));
var import_crypto = require("crypto");
const interfaces = import_os.default.networkInterfaces();
const getLocalHost = () => {
  for (const devName in interfaces) {
    const iface = interfaces[devName];
    if (iface?.length) {
      for (let i = 0; i < iface.length; i++) {
        const alias = iface[i];
        if (alias.family === "IPv4" && alias.address !== "127.0.0.1" && !alias.internal && alias.address.startsWith("10")) {
          return alias.address;
        }
      }
    }
  }
};
const getHash = (env) => {
  const hash = (0, import_crypto.createHash)("md5");
  hash.update(JSON.stringify(env));
  return hash.digest("hex");
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getHash,
  getLocalHost
});
